
Global projekt$
Global ebene_anz%

'Open/Save Dialog Flags
Global Const OFN_READONLY = &H1
Global Const OFN_OVERWRITEPROMPT = &H2
Global Const OFN_HIDEREADONLY = &H4
Global Const OFN_NOCHANGEDIR = &H8
Global Const OFN_SHOWHELP = &H10
Global Const OFN_ENABLEHOOK = &H20
Global Const OFN_ENABLETEMPLATE = &H40
Global Const OFN_ENABLETEMPLATEHANDLE = &H80
Global Const OFN_NOVALIDATE = &H100
Global Const OFN_ALLOWMULTISELECT = &H200
Global Const OFN_EXTENSIONDIFFERENT = &H400
Global Const OFN_PATHMUSTEXIST = &H800
Global Const OFN_FILEMUSTEXIST = &H1000
Global Const OFN_CREATEPROMPT = &H2000
Global Const OFN_SHAREAWARE = &H4000
Global Const OFN_NOREADONLYRETURN = &H8000
Global Const OFN_NOTESTFILECREATE = &H10000
Global Const OFN_SHAREFALLTHROUGH = 2
Global Const OFN_SHARENOWARN = 1
Global Const OFN_SHAREWARN = 0

Type OpenSaveFile
     lStructSize As Long
     hwndOwner As Integer
     hInstance As Integer
     lpstrFilter As Long
     lpstrCustomFilter As Long
     nMaxCustFilter As Long
     nFilterIndex As Long
     lpstrFile As Long
     nMaxFile As Long
     lpstrFileTitle As Long
     nMaxFileTitle As Long
     lpstrInitialDir As Long
     lpstrTitle As Long
     Flags As Long
     nFileOffset As Integer
     nFileExtension As Integer
     lpstrDefExt As Long
     lCustData As Long
     lpfnHook As Long
     lpTemplateName As Long
End Type

Declare Function GetOpenFileName Lib "COMMDLG.DLL" (pOpenSaveFile As OpenSaveFile) As Integer
Declare Function GetSaveFileName Lib "COMMDLG.DLL" (pOpenSaveFile As OpenSaveFile) As Integer

Declare Sub hmemcpy Lib "Kernel" (lpDest As Any, lpSource As Any, ByVal dwBytes As Long)
Declare Function Lstrcpy Lib "KERNEL" (p1 As Any, p2 As Any) As Long
Declare Function GlobalAlloc Lib "Kernel" (ByVal wFlags As Integer, ByVal dwBytes As Long) As Integer
Declare Function GlobalFree Lib "Kernel" (ByVal hMem As Integer) As Integer
Declare Function GlobalLock Lib "Kernel" (ByVal hMem As Integer) As Long
Declare Function GlobalUnlock Lib "Kernel" (ByVal hMem As Integer) As Integer
Global Const GMEM_MOVEABLE = &H2
Global Const GMEM_ZEROINIT = &H40
Global Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)



Global Const MAX_PATH = 32

Type FILETIME
   dwLowDateTime As Long
   dwHighDateTime As Long
End Type

Type WIN32_FIND_DATA
   dwFileAttributes As Long
   ftCreationTime As FILETIME
   ftLastAccessTime As FILETIME
   ftLastWriteTime As FILETIME
   nFileSizeHigh As Long
   nFileSizeLow As Long
   dwReserved0 As Long
   dwReserved1 As Long
   cFilename As String * MAX_PATH
   cAlternate As String * 14
End Type

Function addpfad$ (pfaddat$, ByVal F$)

If Left$(F$, 2) = ".." Then
   p$ = showpath$(pfaddat$)
   Do While Left$(F$, 3) = "..\"
      p$ = showpath$(get_pfad$(p$)): F$ = Mid$(F$, 4)
   Loop
   addpfad$ = p$ + "\" + F$
ElseIf Mid$(F$, 2, 2) = ":\" Then
   addpfad$ = F$
ElseIf Left$(F$, 1) = "\" Then
   addpfad$ = F$
Else
   addpfad$ = pfaddat$ + F$
End If

End Function

Function Dialog_Open$ (F As Form, ByVal ftitle$, fpfad$, ByVal ffile$, ByVal ffilter$, ByVal fext$)

Dim rc%, filesize%, MemHndl%, MemAddr&, osFile As OpenSaveFile
Dialog_Open$ = ""

dr$ = CurDir$

ersetze ffilter$, "|", Chr$(0)
ffilter$ = ffilter$ & Chr$(0) & Chr$(0)

ffile$ = ffile$ & String$(128 - Len(ffile$), 0)
filesize% = Len(ffile$) + Len(ffilter$)

MemHndl% = GlobalAlloc(GHND, filesize%)
If MemHndl% = False Then Exit Function
MemAddr& = GlobalLock(MemHndl%)

Call hmemcpy(ByVal MemAddr&, ByVal (ffile$ + ffilter$ + ftitle$), filesize%)
osFile.lStructSize = Len(osFile)
osFile.hwndOwner = F.hWnd

osFile.Flags = osFile.Flags Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
osFile.nFilterIndex = 1
osFile.lpstrFile = MemAddr&
osFile.nMaxFile = Len(ffile$)
osFile.lpstrFilter = MemAddr& + Len(ffile$)
osFile.lpstrTitle = Lstrcpy(ByVal ftitle$, ByVal ftitle$)
osFile.lpstrDefExt = Lstrcpy(ByVal fext$, ByVal fext$)

If Len(Trim$(fpfad$)) Then  'Convert fpfad$ to a LONG integer
   fpfad$ = showpath$(fpfad$)
   osFile.lpstrInitialDir = Lstrcpy(ByVal fpfad$, ByVal fpfad$)
End If

osFile.Flags = osFile.Flags Or OFN_FILEMUSTEXIST
rc% = GetOpenFileName(osFile)

If rc% <> False Then
   Call hmemcpy(ByVal ffile$, ByVal MemAddr&, Len(ffile$))
   a$ = LCase$(Left$(ffile$, InStr(ffile$, Chr$(0)) - 1))
   Dialog_Open$ = get_file$(a$)
   fpfad$ = get_pfad$(a$)
End If
rc% = GlobalUnlock(MemHndl%)
rc% = GlobalFree(MemHndl%)

ChDir dr$

End Function

Sub ersetze (a$, b$, c$)

If InStr(c$, b$) > 0 And Len(b$) > 0 Then Exit Sub

Do While InStr(a$, b$)
   a$ = Left$(a$, InStr(a$, b$) - 1) + c$ + Mid$(a$, InStr(a$, b$) + Len(b$))
Loop

End Sub

Function exist% (a$)

On Error Resume Next
tmp% = Len(Dir$(a$, 6))
If Err Or tmp% = 0 Then
   exist% = 0
ElseIf GetAttr(a$) And 16 Then
   exist% = 0
Else
   exist% = 1
End If

End Function

Function exist_pfad% (a$)

On Error Resume Next
tmp% = Len(Dir$(a$, 16))
If Err Or tmp% = 0 Then
   exist_pfad% = 0
Else
   exist_pfad% = 1
End If

End Function

Function get_file$ (ByVal a$)
   
Do While InStr(a$, ":")
   F$ = zeichennext$(a$, ":")
Loop
Do While InStr(a$, "\")
   F$ = zeichennext$(a$, "\")
Loop

get_file$ = Trim$(a$)

End Function

Function get_pfad$ (ByVal a$)

p$ = ""
Do While InStr(a$, ":")
   p$ = p$ + zeichennext$(a$, ":") + ":"
Loop
Do While InStr(a$, "\")
   p$ = p$ + zeichennext$(a$, "\") + "\"
Loop

get_pfad$ = Trim$(p$)

End Function

Function is_begin_form% (ByVal a$)

a$ = Trim$(a$)
a1$ = zeichennext$(a$, " ")

If a1$ = "Begin" Then
   a$ = Trim$(a$)
   a1$ = zeichennext$(a$, " ")
   If a1$ = "Form" Or a1$ = "MDIForm" Or a1$ = "VB.Form" Or a1$ = "VB.MDIForm" Then
      is_begin_form% = True
   Else
      is_begin_form% = False
   End If
Else
   is_begin_form% = False
End If

End Function

Function is_sub_or_function% (ByVal a$)

a$ = Trim$(a$)
a1$ = zeichennext$(a$, " ")

If a1$ = "Sub" Or a1$ = "Function" Then
   is_sub_or_function% = True
ElseIf a1$ = "Public" Or a1$ = "Private" Then
   a$ = Trim$(a$)
   a1$ = zeichennext$(a$, " ")
   If a1$ = "Sub" Or a1$ = "Function" Then
      is_sub_or_function% = True
   Else
      is_sub_or_function% = False
   End If
Else
   is_sub_or_function% = False
End If

End Function

Sub maus (m%)

Screen.MousePointer = 11 - 11 * m%

End Sub

Function showpath$ (a$)

If Right$(a$, 1) = "\" And Mid$(a$, 2) <> ":\" Then
  showpath$ = Left$(a$, Len(a$) - 1)
Else
  showpath$ = a$
End If

End Function

Function suche% (l As Control, ByVal a$, art%)

'art%=0:Gleichheit
'    =1:Insert
'    =2:Insert, rckwrts

z1% = 1: z2% = l.ListCount
If z2% = 0 Then suche% = art%: Exit Function

Do Until z1% = z2%
   m% = Int((z1% + z2%) / 2)
   If art% <= 1 Then
      If a$ <= l.List(m% - 1) Then z2% = m% Else z1% = m% + 1
   Else
      If a$ >= l.List(m% - 1) Then z2% = m% Else z1% = m% + 1
   End If
Loop

Select Case art%
Case 0: If a$ = l.List(z1% - 1) Then suche% = z1% Else suche% = 0
Case 1: If a$ <= l.List(z1% - 1) Then suche% = z1% Else suche% = z1% + 1
Case 2: If a$ >= l.List(z1% - 1) Then suche% = z1% Else suche% = z1% + 1
End Select

End Function

Function vorpfad$ (ByVal a$)

a$ = Trim$(a$)

If Right$(a$, 1) <> "\" And Len(a$) > 0 Then a$ = a$ + "\"

vorpfad$ = a$

End Function

Function zeichennext$ (a$, ch$)

ai% = InStr(a$, ch$)
If ai% = 0 Then
  zeichennext$ = a$: a$ = ""
Else
  zeichennext$ = Left$(a$, ai% - 1): a$ = Mid$(a$, ai% + Len(ch$))
End If

End Function

